#ifndef _ROUTE_LOCTAB_H_
#define _ROUTE_LOCTAB_H_

#include "route.h"
#include "loctabroute.h"

class route_loctab : public route_iterator {
 protected:
  ptr<locationtable> locations;
  int nsucc;
  cbhop_t cb;
  ptr<loctabroute> r;

  chordID projkey;
  bool filtering;

  void print_succs();
  bool is_willing(const net_address &addr, bigint projkey);

 public:
  route_loctab (ptr<vnode> vi, chordID xi, int _nsucc);
  route_loctab (ptr<vnode> vi, chordID xi, rpc_program uc_prog,
		int uc_procno, ptr<void> uc_args, int _nsucc);

  route_loctab (ptr<vnode> vi, ptr<loctabroute> ri, chordID xi, chordID _projkey, int _nsucc);
  route_loctab (ptr<vnode> vi, ptr<loctabroute> ri, chordID xi, chordID _projkey, rpc_program uc_prog,
		int uc_procno, ptr<void> uc_args, int _nsucc);

  virtual ~route_loctab ();

  virtual void first_hop (cbhop_t cbi, ptr<chordID> guess);
  virtual void next_hop ();
  virtual void send (ptr<chordID> guess);
  virtual ptr<location> pop_back ();

  //virtual void print ();

};

#endif /* !_ROUTE_LOCTAB_H_ */


