#ifndef _REPLICA_MANAGER_H_
#define _REPLICA_MANAGER_H_

#include "location.h"
#include <chord.h>
#include <chord_types.h>


// startid is the node id of the primary. This returns the successors
// that are replicas for node <startid>.
void
get_succ_replicas(ptr<vnode> host_node, chordID startid, unsigned min, 
		  unsigned max, int max_downtime, vec<ptr<location> > &replicas, 
		  vec<chordID> &range_min, vec<chordID> &range_max,
		  bool include_master);

void
get_pred_replicas(ptr<vnode> host_node, unsigned min, unsigned max, 
		  int max_downtime, vec<ptr<location> > &replicas,
		  vec<chordID> &range_min, vec<chordID> &range_max);



#endif  /* _REPLICA_MANAGER_H_ */

